/// \title GridViewer prototype TEST

#include "gridviewer_prototype.as"

GridViewer viewer_x;
GridViewer viewer_y;
GridViewer viewer_z;

// CONFIG
string meshName = "character.mesh";
string meshRgName = "OgreAutodetect"; // magic!

color nodeColor = color(0.8, 0.9, 0.2, 1.0);
float nodeRadius = 1.f;


// DATA
array<vector3>@ nodes;

// .. nodes

  void drawNodes(GridViewer @viewer) {
    for (uint i=0; i<nodes.length(); i++) {
      ImGui::GetWindowDrawList().AddCircleFilled(
        viewer.projectPos(nodes[i]), nodeRadius, nodeColor);
    }
  }

// STARTUP
void main()
{
  viewer_x.childWindowID = "demoX"; viewer_x.hAxis=1; viewer_x.vAxis=2; // axes: YZ
  viewer_y.childWindowID = "demoY"; viewer_y.hAxis=0; viewer_y.vAxis=2; // axes: XZ
  viewer_z.childWindowID = "demoZ";  // axes  XY (default)
  @nodes = game.getSubMeshVertPositions(meshName, meshRgName, 0);
}

// RENDER
void frameStep(float dt)
{
  vector2 fullsize = ImGui::GetWindowContentRegionMax() - ImGui::GetWindowContentRegionMin();
  vector2 qsize = fullsize*vector2(0.5, 0.5);

  viewer_x.begin(qsize);
  drawNodes(viewer_x);
  viewer_x.end();

  ImGui::SameLine();

  viewer_y.begin(qsize);
  drawNodes(viewer_y);
  viewer_y.end();

  viewer_z.begin(qsize);
  drawNodes(viewer_z);
  viewer_z.end();
}
